#include "Assets.h"

sf::Font& Assets::GetFont() {
    static sf::Font font;
    if (!font.getInfo().family.empty()) return font;
    if (!font.loadFromFile(config::FONT_FILE))
        throw std::runtime_error("Failed to load font");
    return font;
}

sf::Texture& Assets::GetPacmanTexture() {
    static sf::Texture texture;
    if (texture.getSize() != sf::Vector2u{0, 0}) return texture;
    if (!texture.loadFromFile(config::PACMAN_FILE))
        throw std::runtime_error("Failed to load texture: pacman");
    return texture;
}

sf::Texture& Assets::GetEnemyRedTexture() {
    static sf::Texture texture;
    if (texture.getSize() != sf::Vector2u{0, 0})
        return texture;
    if (!texture.loadFromFile(config::ENEMY_RED_FILE))
        throw std::runtime_error("Failed to load texture: enemy red");
    return texture;
}

sf::Texture& Assets::GetEnemyPinkTexture() {
    static sf::Texture texture;
    if (texture.getSize() != sf::Vector2u{0, 0})
        return texture;
    if (!texture.loadFromFile(config::ENEMY_PINK_FILE))
        throw std::runtime_error("Failed to load texture: enemy pink");
    return texture;
}

sf::Texture& Assets::GetEnemyYellowTexture() {
    static sf::Texture texture;
    if (texture.getSize() != sf::Vector2u{0, 0})
        return texture;
    if (!texture.loadFromFile(config::ENEMY_YELLOW_FILE))
        throw std::runtime_error("Failed to load texture: enemy yellow");
    return texture;
}

sf::Texture& Assets::GetEnemyBlueTexture() {
    static sf::Texture texture;
    if (texture.getSize() != sf::Vector2u{0, 0})
        return texture;
    if (!texture.loadFromFile(config::ENEMY_BLUE_FILE))
        throw std::runtime_error("Failed to load texture: enemy blue");
    return texture;
}