#pragma once
#include <SFML/Graphics.hpp>

namespace config {
    // Общее:
    constexpr unsigned int FRAME_RATE_LIMIT = 10;
    // Меню:
    const sf::VideoMode SELECT_LEVEL_VIDEO_MODE{ 400, 600 };
    const sf::Vector2f BUTTON_SIZE = { static_cast<float>(SELECT_LEVEL_VIDEO_MODE.width)/1.6f,
        static_cast<float>(SELECT_LEVEL_VIDEO_MODE.height)/8.f };
    const size_t BUTTON_FONT_SIZE = static_cast<size_t>(BUTTON_SIZE.y / 1.5f);
    constexpr float BUTTON_FRAME_THICKNESS = 2.0f;
    constexpr char FONT_FILE[] = ASSETS_PATH "calibril.ttf";
    constexpr char SELECT_LEVEL_TITLE[] = "Select Level";
    constexpr char BUTTON_TEXT_EASY[] = "Easy";
    constexpr char BUTTON_TEXT_MEDIUM[] = "Medium";
    constexpr char BUTTON_TEXT_HARD[] = "Hard";
    constexpr char BUTTON_TEXT_EXTREME[] = "Extreme";
    constexpr char BUTTON_TEXT_EXIT[] = "Exit";
    const sf::Vector2f BUTTON_CHANGE_THEME_SIZE = { static_cast<float>(SELECT_LEVEL_VIDEO_MODE.width)/2.4f,
        static_cast<float>(SELECT_LEVEL_VIDEO_MODE.height)/16.f };
    const size_t BUTTON_CHANGE_THEME_FONT_SIZE = static_cast<size_t>(BUTTON_CHANGE_THEME_SIZE.y / 2.f);
    constexpr char BUTTON_CHANGE_THEME_DARK[] = "Switch to Dark Mode";
    constexpr char BUTTON_CHANGE_THEME_LIGHT[] = "Switch to Light Mode";
    // Игра:
    const sf::VideoMode GAME_VIDEO_MODE{ 1080, 720 };
    constexpr char PACMAN_FILE[] = ASSETS_PATH "pacman.png";
    constexpr char ENEMY_PINK_FILE[] = ASSETS_PATH "enemy_pink.png";
    constexpr char ENEMY_RED_FILE[] = ASSETS_PATH "enemy_red.png";
    constexpr char ENEMY_BLUE_FILE[] = ASSETS_PATH "enemy_blue.png";
    constexpr char ENEMY_YELLOW_FILE[] = ASSETS_PATH "enemy_yellow.png";
    constexpr size_t ENEMY_ON_SPRITE_COUNT = 8;
    constexpr char EASY_GAME_TITLE[] = "Level: Easy";
    constexpr char MEDIUM_GAME_TITLE[] = "Level: Medium";
    constexpr char HARD_GAME_TITLE[] = "Level: Hard";
    constexpr char EXTREME_GAME_TITLE[] = "Level: Extreme";
    constexpr float EASY_GAME_ENEMY_RATIO = 0.0f;
    constexpr float MEDIUM_GAME_ENEMY_RATIO = 0.03f;
    constexpr float HARD_GAME_ENEMY_RATIO = 0.07f;
    constexpr float ROOM_SIZE = 50;
    constexpr float GAME_ENEMY_SIZE = ROOM_SIZE * 0.8;
    constexpr float GAME_FOOD_SIZE = ROOM_SIZE * 0.1;
    constexpr float ENEMY_SPEED_MEDIEUM = 100;
    constexpr float ENEMY_SPEED_HARD = 150;
    constexpr float ENEMY_SPEED_EXTREME = 250;
    constexpr float PACMAN_SPEED = 450;
    // Пакмэн:
    constexpr float GAME_PACMAN_SIZE = ROOM_SIZE * 0.9;
    constexpr sf::Keyboard::Key KEY_LEFT = sf::Keyboard::A;
    constexpr sf::Keyboard::Key KEY_RIGHT = sf::Keyboard::D;
    constexpr sf::Keyboard::Key KEY_UP = sf::Keyboard::W;
    constexpr sf::Keyboard::Key KEY_DOWN = sf::Keyboard::S;
    constexpr sf::Keyboard::Key KEY_LEFT_2 = sf::Keyboard::Left;
    constexpr sf::Keyboard::Key KEY_RIGHT_2 = sf::Keyboard::Right;
    constexpr sf::Keyboard::Key KEY_UP_2 = sf::Keyboard::Up;
    constexpr sf::Keyboard::Key KEY_DOWN_2 = sf::Keyboard::Down;
    // Состояния игры:
    const sf::Vector2f NOTIFICATION_BANNER_SIZE = {
        static_cast<float>(GAME_VIDEO_MODE.width)/1.5f, static_cast<float>(GAME_VIDEO_MODE.height)/3.0f };
    const size_t NOTIFICATION_FONT_SIZE = static_cast<size_t>(NOTIFICATION_BANNER_SIZE.y / 2.f);
    constexpr char TEXT_PLAY[] = "PRESS SPACE";
    constexpr char TEXT_PAUSE[] = "PAUSE";
    constexpr char TEXT_LOST[] = "DEFEAT!";
    constexpr char TEXT_WIN[] = "WIN!";
    constexpr char TEXT_ON_PROGRESS_BAR[] = "Food eaten: ";
    constexpr char TEXT_ON_PROGRESS_BAR_DEFEATS[] = "Number of defeats: ";
    // Цвета для светлой темы:
    const sf::Color BUTTON_COLOR_TEXT{ 0, 0, 0 };
    const sf::Color BUTTON_COLOR_FILL{ 180, 180, 180 };
    const sf::Color BUTTON_COLOR_SELECTION{ 255, 180, 180 };
    const sf::Color BUTTON_COLOR_FRAME{ 0, 0, 0 };
    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR{ 230,230,230 };
    const sf::Color GAME_COLOR_ROOM{ 255, 255, 255 };
    const sf::Color GAME_COLOR_WALL{ 0, 0, 0 };
    const sf::Color GAME_FOOD_COLOR{ 0, 200, 100 };
    const sf::Color GAME_COLOR_BACKGROUND_INGAME{ 230,230,230 };
    const sf::Color TEXT_COLOR_NOTIFICATION{ 0, 0, 0, 255};
    const sf::Color NOTIFICATION_BANNER_COLOR_PLAY{ 0, 100, 255, 200 };
    const sf::Color GAME_COLOR_BACKGROUND_PAUSE{ 255, 255, 128 };
    const sf::Color NOTIFICATION_BANNER_COLOR_PAUSE{ 240, 240, 120, 200 };
    const sf::Color GAME_COLOR_BACKGROUND_LOST{ 255, 0, 0 };
    const sf::Color NOTIFICATION_BANNER_COLOR_LOST{ 140, 0, 0, 200 };
    const sf::Color GAME_COLOR_BACKGROUND_WIN{ 0, 255, 0 };
    const sf::Color NOTIFICATION_BANNER_COLOR_WIN{ 0, 240, 0, 200 };
    const sf::Color PROGRESS_BAR_BACKGROUND{ 50, 50, 50, 150 };
    const sf::Color PROGRESS_BAR{ 100, 230, 100, 220 };
    const sf::Color TEXT_ON_PROGRESS_BAR_COLOR{ 200, 200, 200, 220 };
    const sf::Color PROGRESS_BAR_LINE{ 100, 200, 200, 220 };
    const sf::Color DEFEATS_COUNT_TEXT{ 255, 255, 255, 220 };
    // Цвета для темной темы:
    const sf::Color BUTTON_COLOR_TEXT_DARK{ 255, 255, 255 };
    const sf::Color BUTTON_COLOR_FILL_DARK{ 50, 50, 50 };
    const sf::Color BUTTON_COLOR_SELECTION_DARK{ 100, 50, 50 };
    const sf::Color BUTTON_COLOR_FRAME_DARK{ 255, 255, 255 };
    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR_DARK{ 30, 30, 30 };
    const sf::Color GAME_COLOR_ROOM_DARK{ 50, 50, 50 };
    const sf::Color GAME_COLOR_WALL_DARK{ 200, 200, 200 };
    const sf::Color GAME_FOOD_COLOR_DARK{ 0, 150, 75 };
    const sf::Color GAME_COLOR_BACKGROUND_INGAME_DARK{ 20, 20, 20 };
    const sf::Color TEXT_COLOR_NOTIFICATION_DARK{ 255, 255, 255, 255 };
    const sf::Color NOTIFICATION_BANNER_COLOR_PLAY_DARK{ 0, 50, 150, 200 };
    const sf::Color GAME_COLOR_BACKGROUND_PAUSE_DARK{ 100, 100, 50 };
    const sf::Color NOTIFICATION_BANNER_COLOR_PAUSE_DARK{ 100, 100, 50, 200 };
    const sf::Color GAME_COLOR_BACKGROUND_LOST_DARK{ 150, 0, 0 };
    const sf::Color NOTIFICATION_BANNER_COLOR_LOST_DARK{ 150, 0, 0, 180 };
    const sf::Color GAME_COLOR_BACKGROUND_WIN_DARK{ 0, 150, 0 };
    const sf::Color NOTIFICATION_BANNER_COLOR_WIN_DARK{ 0, 120, 0, 200 };
    const sf::Color PROGRESS_BAR_BACKGROUND_DARK{ 20, 20, 20, 150 };
    const sf::Color PROGRESS_BAR_FILL_DARK{ 50, 80, 50, 150 };
    const sf::Color PROGRESS_BAR_DARK{ 100, 200, 100, 220};
    const sf::Color TEXT_ON_PROGRESS_BAR_COLOR_DARK{ 200, 200, 200, 220};
    const sf::Color PROGRESS_BAR_LINE_DARK{ 100, 200, 200, 220 };
}