#pragma once
#include <BasicAbstractions/IState.h>
#include <BasicAbstractions/IDrawable.h>
#include <BasicAbstractions/Button/Button.h>
#include <array>

class SelectState;

class Menu final : public IDrawable {
public:
    explicit Menu(IStateManager& state_manager);
    void process_mouse(sf::Vector2f pos, bool is_pressed);
    void draw_into(sf::RenderWindow& window) const override;
    friend class ChangeThemeCommand;
private:
    std::array<Button, 6> m_buttons;
    IStateManager& m_state_manager;
};